
# WSO2 API Manager Analytics

---

[![Build Status](https://wso2.org/jenkins/view/analytics/job/analytics-products/job/analytics-apim/badge/icon)](https://wso2.org/jenkins/view/analytics/job/analytics-products/job/analytics-apim/)
[![License](https://img.shields.io/badge/License-Apache%202.0-blue.svg)](https://opensource.org/licenses/Apache-2.0)
[![GitHub Release](https://img.shields.io/github/release-pre/wso2/analytics-apim.svg)](https://github.com/wso2/analytics-apim/releases/)
[![GitHub Release Date](https://img.shields.io/github/release-date-pre/wso2/analytics-apim.svg)](https://github.com/wso2/analytics-apim/releases)
[![GitHub Open Issues](https://img.shields.io/github/issues-raw/wso2/analytics-apim.svg)](https://github.com/wso2/analytics-apim/commits/master)
[![GitHub Last Commit](https://img.shields.io/github/last-commit/wso2/analytics-apim.svg)](https://github.com/wso2/analytics-apim/commits/master)
[![stackoverflow](https://img.shields.io/badge/stackoverflow-wso2am-orange)](https://stackoverflow.com/tags/wso2-am/)
[![slack](https://img.shields.io/badge/slack-wso2--apim-blueviolet)](https://wso2-apim.slack.com/)

---

WSO2 API Analytics provides the capability to monitor API invocations and to summarize statistics in order to
 monetize API usage. WSO2 API Manager analytics is powered by the WSO2 Streaming Integrator(SI).

# WSO2 API Manager Analytics can monitor the following:

- API Subscriptions: Number of subscriptions per API (across all versions of an API)
- API Usage: Number of API calls being made per API (across all versions of an API)
- API Response Times: 
- API Last Access Times: The subscribers who did the last 10 API invocations and the APIs/versions they invoked
- API Usage by Resource Path: Usage of an API and from which resource path (per API version)
- API Usage by Destination: Destination-based usage tracking, if enabled
- API Usage by User: Number of times a user has accessed an API
- Faulty Invocations: The number of API invocations that failed to reach the endpoint per API per user

You can install the WSO2 API Manager analytics component by following the documentation found at https://apim.docs.wso2.com/en/latest/learn/analytics/overview-of-api-analytics/

# How to Contribute

Send your pull requests to [analytics-apim](https://github.com/wso2/analytics-apim).

# Reporting Issues

We encourage you to report issues, documentation faults and feature requests regarding WSO2 API Manager Analytics through the [WSO2 API Manager Analytics Issue Tracker](https://github.com/wso2/analytics-apim/issues).

When reporting security issues, please report them to [security@wso2.com](mailto:security@wso2.com), and make sure that you adhere to [WSO2 Security Vulnerability Reporting Guidelines](https://docs.wso2.com/display/Security/WSO2+Security+Vulnerability+Reporting+Guidelines). 

# Contact us
You can talk to us via the mailing lists or our slack channel:

- WSO2 Developers List : dev@wso2.org
- WSO2 Architecture List : architecture@wso2.org
- WSO2 APIM Slack Channel: https://wso2-apim.slack.com/

